/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "epoch_table.hh"
#include <iostream>

using namespace sends;
using namespace std;

//======================================  Constructor
epoch_table::epoch_table(void) {
    add("ALL",  epoch(0));
    add("NONE", epoch(0,0));
}

//======================================  Destructor
epoch_table::~epoch_table(void) {
}

//======================================  Add an epoch to the table
void 
epoch_table::add(const std::string& name, const epoch& epic) {
    mTable.insert(epoch_map::value_type(name, epic));
}

//======================================  Print epochs, one per line
std::ostream& 
epoch_table::display(std::ostream& out) const {
    out << "Epoch table contents: " << endl;
    for (const_epoch_iter i=mTable.begin(); i != mTable.end(); ++i) {
	out << i->first << string(16-i->first.size(), ' ') << i->second << endl;
    }
    return out;
}

//======================================  List epochs as <epoch>=<start>-<end>
std::ostream& 
epoch_table::list(std::ostream& out) const {
    for (const_epoch_iter i=mTable.begin(); i != mTable.end(); ++i) {
	if (i != mTable.begin()) out << " ";
	out << i->first << "=";
	i->second.display(out);
    }
    return out;
}
